From: Robin Cornelius <robin.cornelius@gmail.com>
Subject: [PATCH] topic/fixes/jira-sent/VWR-11138_Develop_py_and_express_VS

<patch description>

Signed-off-by: Robin Cornelius <robin.cornelius@gmail.com>

---
 indra/develop.py |   49 ++++++++++++++++++++++++++++++++++++++++++++++---
 1 files changed, 46 insertions(+), 3 deletions(-)

diff --git a/indra/develop.py b/indra/develop.py
index 29fe0e8..bb12437 100755
--- a/indra/develop.py
+++ b/indra/develop.py
@@ -464,8 +464,15 @@ class WindowsSetup(PlatformSetup):
                     print 'Building with ', self.gens[version]['gen']
                     break
             else:
-                print >> sys.stderr, 'Cannot find a Visual Studio installation!'
-                eys.exit(1)
+                print >> sys.stderr, 'Cannot find a Visual Studio installation, testing for express editions'
+                for version in 'vc80 vc90 vc71'.split():
+                    if self.find_visual_studio_express(version):
+                        self._generator = version
+                        print 'Building with ', self.gens[version]['gen'] , "Express edition"
+                        break
+                else:
+                    print >> sys.stderr, 'Cannot find any Visual Studio installation'
+                    eys.exit(1)
         return self._generator
 
     def _set_generator(self, gen):
@@ -515,6 +522,29 @@ class WindowsSetup(PlatformSetup):
         except WindowsError, err:
             print >> sys.stderr, "Didn't find ", self.gens[gen]['gen']
             return ''
+        
+    def find_visual_studio_express(self, gen=None):
+        if gen is None:
+            gen = self._generator
+        gen = gen.lower()
+        try:
+            import _winreg
+            key_str = (r'SOFTWARE\Microsoft\VCEXpress\%s\Setup\VC' %
+                       self.gens[gen]['ver'])
+            value_str = (r'ProductDir')
+            print ('Reading VS environment from HKEY_LOCAL_MACHINE\%s\%s' %
+                   (key_str, value_str))
+            print key_str
+
+            reg = _winreg.ConnectRegistry(None, _winreg.HKEY_LOCAL_MACHINE)
+            key = _winreg.OpenKey(reg, key_str)
+            value = _winreg.QueryValueEx(key, value_str)[0]+"IDE"
+            print 'Found: %s' % value
+            return value
+        except WindowsError, err:
+            print >> sys.stderr, "Didn't find ", self.gens[gen]['gen']
+            return ''
+
 
     def get_build_cmd(self):
         if self.incredibuild:
@@ -524,9 +554,22 @@ class WindowsSetup(PlatformSetup):
 
             return "buildconsole Secondlife.sln /build %s" % config
 
+        environment = self.find_visual_studio()
+        if environment == '':
+            environment = self.find_visual_studio_express()
+            if environment == '':
+                 print >> sys.stderr, "Something went very wrong during build stage, could not find a Visual Studio?"
+            else:
+                 print >> sys.stderr, "\nSolution generation complete, as you are using an express edition the final\n stages will need to be completed by hand"
+                 build_dirs=self.build_dirs();
+                 print >> sys.stderr, "Solution can now be found in:", build_dirs[0]
+                 print >> sys.stderr, "Set secondlife-bin as startup project"
+                 print >> sys.stderr, "Set build target is Release or RelWithDbgInfo"
+                 exit(0)
+    
         # devenv.com is CLI friendly, devenv.exe... not so much.
         return ('"%sdevenv.com" Secondlife.sln /build %s' % 
-                (self.find_visual_studio(), self.build_type))
+                (environment, self.build_type))
 
     # this override of run exists because the PlatformSetup version
     # uses Unix/Mac only calls. Freakin' os module!
-- 
tg: (1836a2b..) topic/fixes/jira-sent/VWR-11138_Develop_py_and_express_VS (depends on: upstream)
